"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var enumerable_1 = require("./enumerable");
var equality_comparer_1 = require("./equality-comparer");
var exceptions_1 = require("./exceptions");
var key_value_pair_1 = require("./key-value-pair");
var utils = __importStar(require("./utils"));
var Dictionary = /** @class */ (function () {
    function Dictionary(dictionary, comparer) {
        var e_1, _a;
        this.freeList = -1;
        this.freeCount = 0;
        this.version = 0;
        this.count = 0;
        this.comparer = comparer || equality_comparer_1.EqualityComparer.Default();
        if (dictionary) {
            if (typeof dictionary === 'number') {
                var capacity = dictionary;
                if (capacity < 0) {
                    throw new exceptions_1.ArgumentOutOfRangeException('capacity', capacity, 'capacity 小于 0');
                }
                this.Initialize(capacity);
            }
            else {
                try {
                    for (var dictionary_1 = __values(dictionary), dictionary_1_1 = dictionary_1.next(); !dictionary_1_1.done; dictionary_1_1 = dictionary_1.next()) {
                        var item = dictionary_1_1.value;
                        if (item instanceof key_value_pair_1.KeyValuePair) {
                            this.Set(item.Key, item.Value);
                        }
                        else {
                            this.Set(item[0], item[1]);
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (dictionary_1_1 && !dictionary_1_1.done && (_a = dictionary_1.return)) _a.call(dictionary_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
        }
    }
    Dictionary.prototype.Initialize = function (capacity) {
        var size = HashHelpers.GetPrime(capacity);
        var buckets = new Array(size);
        var entries = new Array(size);
        for (var i = 0; i < size; i++) {
            buckets[i] = -1;
            entries[i] = new Entry();
        }
        this.buckets = buckets;
        this.entries = entries;
        this.freeList = -1;
        return size;
    };
    Dictionary.prototype.Add = function (key, value) {
        this.TryInsert(key, value, InsertionBehavior.ThrowOnExisting);
    };
    Dictionary.prototype.Set = function (key, value) {
        this.TryInsert(key, value, InsertionBehavior.OverwriteExisting);
    };
    Dictionary.prototype.Get = function (key) {
        var i = this.FindEntry(key);
        if (i >= 0) {
            var entries = this.entries;
            return entries[i].value;
        }
        throw new exceptions_1.KeyNotFoundException();
    };
    Dictionary.prototype.ContainsKey = function (key) {
        return this.FindEntry(key) >= 0;
    };
    Dictionary.prototype.Clear = function () {
        if (this.count > 0) {
            var buckets = this.buckets;
            var entries = this.entries;
            for (var i = 0; i < buckets.length; i++) {
                buckets[i] = -1;
            }
            for (var i = 0; i < entries.length; i++) {
                entries[i] = new Entry();
            }
            this.freeList = -1;
            this.count = 0;
            this.freeCount = 0;
            this.version++;
        }
    };
    Dictionary.prototype.Remove = function (key) {
        utils.throws.ThrowIfNull('key', key);
        var buckets = this.buckets;
        var entries = this.entries;
        var comparer = this.comparer;
        if (buckets) {
            var hashCode = comparer.GetHashCode(key) & 0x7fffffff;
            var bucket = hashCode % buckets.length;
            var last = -1;
            for (var i = buckets[bucket]; i >= 0; last = i, i = entries[i].next) {
                if (entries[i].hashCode === hashCode &&
                    comparer.Equals(entries[i].key, key)) {
                    if (last < 0) {
                        buckets[bucket] = entries[i].next;
                    }
                    else {
                        entries[last].next = entries[i].next;
                    }
                    entries[i].hashCode = -1;
                    entries[i].next = this.freeList;
                    entries[i].key = undefined;
                    entries[i].value = undefined;
                    this.freeList = i;
                    this.freeCount++;
                    this.version++;
                    return true;
                }
            }
        }
        return false;
    };
    Dictionary.prototype.TryGetValue = function (key) {
        var i = this.FindEntry(key);
        if (i >= 0) {
            var entries = this.entries;
            var value = entries[i].value;
            return [true, value];
        }
        return [false, undefined];
    };
    Dictionary.prototype.FindEntry = function (key) {
        utils.throws.ThrowIfNull('key', key);
        var buckets = this.buckets;
        var entries = this.entries;
        var comparer = this.comparer;
        if (buckets) {
            var hashCode = comparer.GetHashCode(key) & 0x7fffffff;
            for (var i = buckets[hashCode % buckets.length]; i >= 0; i = entries[i].next) {
                if (entries[i].hashCode === hashCode &&
                    comparer.Equals(entries[i].key, key)) {
                    return i;
                }
            }
        }
        return -1;
    };
    Dictionary.prototype.TryInsert = function (key, value, behavior) {
        utils.throws.ThrowIfNull('key', key);
        if (!this.buckets) {
            this.Initialize(0);
        }
        var buckets = this.buckets;
        var entries = this.entries;
        var comparer = this.comparer;
        var hashCode = comparer.GetHashCode(key) & 0x7fffffff;
        var targetBucket = hashCode % this.buckets.length;
        for (var i = buckets[targetBucket]; i >= 0; i = entries[i].next) {
            if (entries[i].hashCode === hashCode &&
                comparer.Equals(entries[i].key, key)) {
                if (behavior === InsertionBehavior.ThrowOnExisting) {
                    throw new exceptions_1.ArgumentException('key', '已经存在相同的Key');
                }
                entries[i].value = value;
                this.version++;
                return true;
            }
        }
        var index = 0;
        if (this.freeCount > 0) {
            index = this.freeList;
            this.freeList = entries[index].next;
            this.freeCount--;
        }
        else {
            if (this.count === entries.length) {
                this.Resize();
                entries = this.entries;
                buckets = this.buckets;
                targetBucket = hashCode % buckets.length;
            }
            index = this.count;
            this.count++;
        }
        entries[index].hashCode = hashCode;
        entries[index].next = buckets[targetBucket];
        entries[index].key = key;
        entries[index].value = value;
        buckets[targetBucket] = index;
        this.version++;
    };
    Dictionary.prototype.Resize = function () {
        var newSize = HashHelpers.GetPrime(this.count * 2);
        var newBuckets = new Array();
        for (var i = 0; i < newSize; i++) {
            newBuckets[i] = -1;
        }
        var newEntries = new Array();
        var entries = this.entries;
        for (var i = 0; i < newSize; i++) {
            if (i < this.count) {
                newEntries[i] = entries[i];
            }
            else {
                newEntries[i] = new Entry();
            }
        }
        for (var i = 0; i < this.count; i++) {
            var bucket = newEntries[i].hashCode % newSize;
            newEntries[i].next = newBuckets[bucket];
            newBuckets[bucket] = i;
        }
        this.buckets = newBuckets;
        this.entries = newEntries;
    };
    Dictionary.prototype[Symbol.iterator] = function () {
        var e_2, _a, _b, _c, item, e_2_1;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    if (!this.entries) return [3 /*break*/, 8];
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _b = __values(this.entries), _c = _b.next();
                    _d.label = 2;
                case 2:
                    if (!!_c.done) return [3 /*break*/, 5];
                    item = _c.value;
                    if (!(item.key !== undefined)) return [3 /*break*/, 4];
                    return [4 /*yield*/, new key_value_pair_1.KeyValuePair(item.key, item.value)];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _c = _b.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_2_1 = _d.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 8: return [2 /*return*/];
            }
        });
    };
    Dictionary.prototype.All = function (predicate) {
        return enumerable_1.Enumerable.All(this, predicate);
    };
    Dictionary.prototype.Any = function (predicate) {
        return enumerable_1.Enumerable.Any(this, predicate);
    };
    Dictionary.prototype.AsEnumerable = function () {
        return enumerable_1.Enumerable.AsEnumerable(this);
    };
    Dictionary.prototype.Average = function (selector) {
        return enumerable_1.Enumerable.Average(this, selector);
    };
    Dictionary.prototype.Concat = function (second) {
        return enumerable_1.Enumerable.Concat(this, second);
    };
    Dictionary.prototype.Contains = function (value, comparer) {
        return enumerable_1.Enumerable.Contains(this, value, comparer);
    };
    Dictionary.prototype.Count = function (predicate) {
        if (predicate) {
            return enumerable_1.Enumerable.Count(this, predicate);
        }
        else {
            return this.count - this.freeCount;
        }
    };
    Dictionary.prototype.DefaultIfEmpty = function (defaultValue) {
        return enumerable_1.Enumerable.DefaultIfEmpty(this, defaultValue);
    };
    Dictionary.prototype.Distinct = function (comparer) {
        return enumerable_1.Enumerable.Distinct(this, comparer);
    };
    Dictionary.prototype.ElementAt = function (index) {
        return enumerable_1.Enumerable.ElementAt(this, index);
    };
    Dictionary.prototype.ElementAtOrDefault = function (defaultValue, index) {
        return enumerable_1.Enumerable.ElementAtOrDefault(this, defaultValue, index);
    };
    Dictionary.prototype.Except = function (second, comparer) {
        return enumerable_1.Enumerable.Except(this, second, comparer);
    };
    Dictionary.prototype.First = function (predicate) {
        return enumerable_1.Enumerable.First(this, predicate);
    };
    Dictionary.prototype.FirstOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.FirstOrDefault(this, defaultValue, predicate);
    };
    Dictionary.prototype.GroupBy = function (keySelector, elementSelector, comparer) {
        return enumerable_1.Enumerable.GroupBy(this, keySelector, elementSelector, comparer);
    };
    Dictionary.prototype.GroupJoin = function (inner, outerKeySelector, innerKeySelector, resultSelector, comparer) {
        return enumerable_1.Enumerable.GroupJoin(this, inner, outerKeySelector, innerKeySelector, resultSelector, comparer);
    };
    Dictionary.prototype.Intersect = function (second, comparer) {
        return enumerable_1.Enumerable.Intersect(this, second, comparer);
    };
    Dictionary.prototype.Join = function (inner, outerKeySelector, innerKeySelector, resultSelector, comparer) {
        return enumerable_1.Enumerable.Join(this, inner, outerKeySelector, innerKeySelector, resultSelector, comparer);
    };
    Dictionary.prototype.Last = function (predicate) {
        return enumerable_1.Enumerable.Last(this, predicate);
    };
    Dictionary.prototype.LastOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.LastOrDefault(this, defaultValue, predicate);
    };
    Dictionary.prototype.Max = function (selector) {
        return enumerable_1.Enumerable.Max(this, selector);
    };
    Dictionary.prototype.Min = function (selector) {
        return enumerable_1.Enumerable.Min(this, selector);
    };
    Dictionary.prototype.Reverse = function () {
        return enumerable_1.Enumerable.Reverse(this);
    };
    Dictionary.prototype.Select = function (selector) {
        return enumerable_1.Enumerable.Select(this, selector);
    };
    Dictionary.prototype.SelectMany = function (collectionSelector, resultSelector) {
        return enumerable_1.Enumerable.SelectMany(this, collectionSelector, resultSelector);
    };
    Dictionary.prototype.SequenceEqual = function (second, comparer) {
        return enumerable_1.Enumerable.SequenceEqual(this, second, comparer);
    };
    Dictionary.prototype.Single = function (predicate) {
        return enumerable_1.Enumerable.Single(this, predicate);
    };
    Dictionary.prototype.SingleOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.SingleOrDefault(this, defaultValue, predicate);
    };
    Dictionary.prototype.Skip = function (count) {
        return enumerable_1.Enumerable.Skip(this, count);
    };
    Dictionary.prototype.SkipWhile = function (predicate) {
        return enumerable_1.Enumerable.SkipWhile(this, predicate);
    };
    Dictionary.prototype.Sum = function (selector) {
        return enumerable_1.Enumerable.Sum(this, selector);
    };
    Dictionary.prototype.Take = function (count) {
        return enumerable_1.Enumerable.Take(this, count);
    };
    Dictionary.prototype.TakeWhile = function (predicate) {
        return enumerable_1.Enumerable.TakeWhile(this, predicate);
    };
    Dictionary.prototype.ToArray = function () {
        return enumerable_1.Enumerable.ToArray(this);
    };
    Dictionary.prototype.ToDictionary = function (keySelector, elementSelector, comparer) {
        return enumerable_1.Enumerable.ToDictionary(this, keySelector, elementSelector, comparer);
    };
    Dictionary.prototype.ToList = function () {
        return enumerable_1.Enumerable.ToList(this);
    };
    Dictionary.prototype.Union = function (second, comparer) {
        return enumerable_1.Enumerable.Union(this, second, comparer);
    };
    Dictionary.prototype.Where = function (predicate) {
        return enumerable_1.Enumerable.Where(this, predicate);
    };
    return Dictionary;
}());
exports.Dictionary = Dictionary;
var Entry = /** @class */ (function () {
    function Entry() {
        this.hashCode = 0;
        this.next = -1;
        this.key = undefined;
        this.value = undefined;
    }
    return Entry;
}());
var InsertionBehavior;
(function (InsertionBehavior) {
    InsertionBehavior[InsertionBehavior["None"] = 0] = "None";
    InsertionBehavior[InsertionBehavior["OverwriteExisting"] = 1] = "OverwriteExisting";
    InsertionBehavior[InsertionBehavior["ThrowOnExisting"] = 2] = "ThrowOnExisting";
})(InsertionBehavior || (InsertionBehavior = {}));
var HashHelpers = /** @class */ (function () {
    function HashHelpers() {
    }
    HashHelpers.IsPrime = function (candidate) {
        /* istanbul ignore else */
        if ((candidate & 1) !== 0) {
            var limit = parseInt(Math.sqrt(candidate).toFixed(0), 10);
            for (var divisor = 3; divisor <= limit; divisor += 2) {
                /* istanbul ignore next */
                if (candidate % divisor === 0) {
                    return false;
                }
            }
            return true;
        }
        /* istanbul ignore next */
        return candidate === 2;
    };
    HashHelpers.GetPrime = function (min) {
        for (var i = 0; i < PRIMES.length; i++) {
            var prime = PRIMES[i];
            if (prime >= min) {
                return prime;
            }
        }
        for (var i = min | 1; i < 2147483647; i += 2) {
            /* istanbul ignore else */
            if (HashHelpers.IsPrime(i) && (i - 1) % HashHelpers.HashPrime !== 0) {
                return i;
            }
        }
        /* istanbul ignore next */
        return min;
    };
    HashHelpers.HashPrime = 101;
    return HashHelpers;
}());
var PRIMES = [
    3,
    7,
    11,
    17,
    23,
    29,
    37,
    47,
    59,
    71,
    89,
    107,
    131,
    163,
    197,
    239,
    293,
    353,
    431,
    521,
    631,
    761,
    919,
    1103,
    1327,
    1597,
    1931,
    2333,
    2801,
    3371,
    4049,
    4861,
    5839,
    7013,
    8419,
    10103,
    12143,
    14591,
    17519,
    21023,
    25229,
    30293,
    36353,
    43627,
    52361,
    62851,
    75431,
    90523,
    108631,
    130363,
    156437,
    187751,
    225307,
    270371,
    324449,
    389357,
    467237,
    560689,
    672827,
    807403,
    968897,
    1162687,
    1395263,
    1674319,
    2009191,
    2411033,
    2893249,
    3471899,
    4166287,
    4999559,
    5999471,
    7199369
];
//# sourceMappingURL=dictionary.js.map