"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var dictionary_1 = require("../dictionary");
var equality_comparer_1 = require("../equality-comparer");
var utils = __importStar(require("../utils"));
function toDictionary(source, keySelector, elementSelector, comparer) {
    var e_1, _a;
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('keySelector', keySelector);
    var _elementSelector = elementSelector || (function (x) { return x; });
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    var dictionary = new dictionary_1.Dictionary(null, comparer);
    try {
        for (var source_1 = __values(source), source_1_1 = source_1.next(); !source_1_1.done; source_1_1 = source_1.next()) {
            var item = source_1_1.value;
            var key = keySelector(item);
            var value = _elementSelector(item);
            dictionary.Add(key, value);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return dictionary;
}
exports.toDictionary = toDictionary;
//# sourceMappingURL=to-dictionary.js.map