"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var HASH_CODE = Symbol('HASH_CODE');
var EqualityComparer = /** @class */ (function () {
    function EqualityComparer() {
    }
    EqualityComparer.prototype.GetHashCode = function (obj) {
        var hash = 0;
        if (obj) {
            if (typeof obj === 'number') {
                return obj;
            }
            if (typeof obj === 'string') {
                return stringHashCode(obj);
            }
            hash = obj[HASH_CODE];
            if (hash !== undefined) {
                return hash;
            }
            hash = getHashCode();
            obj[HASH_CODE] = hash;
        }
        return hash;
    };
    EqualityComparer.Default = function () {
        return new DefaultEqualityComparer();
    };
    return EqualityComparer;
}());
exports.EqualityComparer = EqualityComparer;
var DefaultEqualityComparer = /** @class */ (function (_super) {
    __extends(DefaultEqualityComparer, _super);
    function DefaultEqualityComparer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultEqualityComparer.prototype.Equals = function (x, y) {
        return x === y;
    };
    return DefaultEqualityComparer;
}(EqualityComparer));
function getHashCode() {
    var timestamp = new Date().valueOf();
    var word = randomWord(6, 32);
    return stringHashCode(word + timestamp.toString());
}
function stringHashCode(text) {
    var hash = 0;
    /* istanbul ignore else */
    if (text) {
        for (var i = 0; i < text.length; i++) {
            hash = hash * 31 + text.charCodeAt(i);
            hash = intValue(hash);
        }
    }
    return hash;
}
function intValue(num) {
    if (num > MAX_VALUE || num < MIN_VALUE) {
        return (num &= 0xffffffff);
    }
    return num;
}
var MAX_VALUE = 0x7fffffff;
var MIN_VALUE = -0x80000000;
var ALPHAS = [
    '0',
    '1',
    '2',
    '3',
    '4',
    '5',
    '6',
    '7',
    '8',
    '9',
    'A',
    'B',
    'C',
    'D',
    'E',
    'F',
    'G',
    'H',
    'I',
    'J',
    'K',
    'L',
    'M',
    'N',
    'O',
    'P',
    'Q',
    'R',
    'S',
    'T',
    'U',
    'V',
    'W',
    'X',
    'Y',
    'Z'
];
function randomWord(min, max) {
    var text = '';
    var length = min;
    /* istanbul ignore else */
    if (max && max > min) {
        length = Math.round(Math.random() * (max - min)) + min;
    }
    for (var i = 0; i < length; i++) {
        var position = Math.round(Math.random() * (ALPHAS.length - 1));
        text += ALPHAS[position];
    }
    return text;
}
//# sourceMappingURL=equality-comparer.js.map